ework.grace-shell.2023.1.0-M2.source-code.unixStartScript.txt Maven / Gradle / Ivy
Go to download
Show more of this group Show more artifacts with this name
Show all versions of grace-shell Show documentation
Show all versions of grace-shell Show documentation
Grace Framework : Grace Shell
#!/bin/sh
#
# Copyright © 2015-2024 the original authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
##############################################################################
#
# ${applicationName} start up script for POSIX generated by Gradle.
#
##############################################################################
# Attempt to set APP_HOME
# Resolve links: \$0 may be a link
app_path=\$0
# Need this for daisy-chained symlinks.
while
APP_HOME=\${app_path%"\${app_path##*/}"} # leaves a trailing /; empty if no leading path
[ -h "\$app_path" ]
do
ls=\$( ls -ld "\$app_path" )
link=\${ls#*' -> '}
case \$link in #(
/*) app_path=\$link ;; #(
*) app_path=\$APP_HOME\$link ;;
esac
done
# This is normally unused
# shellcheck disable=SC2034
APP_BASE_NAME=\${0##*/}
APP_HOME=\$( cd "\${APP_HOME:-./}${appHomeRelativePath}" && pwd -P ) || exit
# Add default JVM options here. You can also use JAVA_OPTS and ${optsEnvironmentVar} to pass JVM options to this script.
DEFAULT_JVM_OPTS=${defaultJvmOpts}
# Use the maximum available, or set MAX_FD != -1 to use that value.
MAX_FD=maximum
warn () {
echo "\$*"
} >&2
die () {
echo
echo "\$*"
echo
exit 1
} >&2
# OS specific support (must be 'true' or 'false').
cygwin=false
msys=false
darwin=false
nonstop=false
case "\$( uname )" in #(
CYGWIN* ) cygwin=true ;; #(
Darwin* ) darwin=true ;; #(
MSYS* | MINGW* ) msys=true ;; #(
NONSTOP* ) nonstop=true ;;
esac
CLASSPATH=$classpath
for f in "\$APP_HOME"/lib/ext/*; do
[[ "\$cygwin" == "true" ]] && LIBFILE=\$(cygpath "\$f") || LIBFILE=\$f
CLASSPATH=\$CLASSPATH:\$LIBFILE
done
<% if ( mainClassName.startsWith('--module ') ) { %>
MODULE_PATH=$modulePath
<% } %>
# Determine the Java command to use to start the JVM.
if [ -n "\$JAVA_HOME" ] ; then
if [ -x "\$JAVA_HOME/jre/sh/java" ] ; then
# IBM's JDK on AIX uses strange locations for the executables
JAVACMD=\$JAVA_HOME/jre/sh/java
else
JAVACMD=\$JAVA_HOME/bin/java
fi
if [ ! -x "\$JAVACMD" ] ; then
die "ERROR: JAVA_HOME is set to an invalid directory: \$JAVA_HOME
Please set the JAVA_HOME variable in your environment to match the
location of your Java installation."
fi
else
JAVACMD=java
which java >/dev/null 2>&1 || die "ERROR: JAVA_HOME is not set and no 'java' command could be found in your PATH.
Please set the JAVA_HOME variable in your environment to match the
location of your Java installation."
fi
# Increase the maximum file descriptors if we can.
if ! "\$cygwin" && ! "\$darwin" && ! "\$nonstop" ; then
case \$MAX_FD in #(
max*)
# In POSIX sh, ulimit -H is undefined. That's why the result is checked to see if it worked.
# shellcheck disable=SC3045
MAX_FD=\$( ulimit -H -n ) ||
warn "Could not query maximum file descriptor limit"
esac
case \$MAX_FD in #(
'' | soft) :;; #(
*)
# In POSIX sh, ulimit -n is undefined. That's why the result is checked to see if it worked.
# shellcheck disable=SC3045
ulimit -n "\$MAX_FD" ||
warn "Could not set maximum file descriptor limit to \$MAX_FD"
esac
fi
# Collect all arguments for the java command, stacking in reverse order:
# * args from the command line
# * the main class name
# * -classpath
# * -D...appname settings
# * --module-path (only if needed)
# * DEFAULT_JVM_OPTS, JAVA_OPTS, and ${optsEnvironmentVar} environment variables.
# For Cygwin or MSYS, switch paths to Windows format before running java
if "\$cygwin" || "\$msys" ; then
APP_HOME=\$( cygpath --path --mixed "\$APP_HOME" )
CLASSPATH=\$( cygpath --path --mixed "\$CLASSPATH" )
<% if ( mainClassName.startsWith('--module ') ) { %> MODULE_PATH=\$( cygpath --path --mixed "\$MODULE_PATH" )<% } %>
JAVACMD=\$( cygpath --unix "\$JAVACMD" )
# Now convert the arguments - kludge to limit ourselves to /bin/sh
for arg do
if
case \$arg in #(
-*) false ;; # don't mess with options #(
/?*) t=\${arg#/} t=/\${t%%/*} # looks like a POSIX filepath
[ -e "\$t" ] ;; #(
*) false ;;
esac
then
arg=\$( cygpath --path --ignore --mixed "\$arg" )
fi
# Roll the args list around exactly as many times as the number of
# args, so each arg winds up back in the position where it started, but
# possibly modified.
#
# NB: a `for` loop captures its iteration list before it begins, so
# changing the positional parameters here affects neither the number of
# iterations, nor the values presented in `arg`.
shift # remove old arg
set -- "\$@" "\$arg" # push replacement arg
done
fi
# Collect all arguments for the java command;
# * \$DEFAULT_JVM_OPTS, \$JAVA_OPTS, and \$${optsEnvironmentVar} can contain fragments of
# shell script including quotes and variable substitutions, so put them in
# double quotes to make sure that they get re-expanded; and
# * put everything else in single quotes, so that it's not re-expanded.
set -- \\
<% if ( appNameSystemProperty ) {
%> "-D${appNameSystemProperty}=\$APP_BASE_NAME" \\
<% } %> -classpath "\$CLASSPATH" \\
<% if ( mainClassName.startsWith('--module ') ) {
%> --module-path "\$MODULE_PATH" \\
<% } %> ${mainClassName} \\
"\$@"
# Stop when "xargs" is not available.
if ! command -v xargs >/dev/null 2>&1
then
die "xargs is not available"
fi
# Use "xargs" to parse quoted args.
#
# With -n1 it outputs one arg per line, with the quotes and backslashes removed.
#
# In Bash we could simply go:
#
# readarray ARGS < <( xargs -n1 <<<"\$var" ) &&
# set -- "\${ARGS[@]}" "\$@"
#
# but POSIX shell has neither arrays nor command substitution, so instead we
# post-process each arg (as a line of input to sed) to backslash-escape any
# character that might be a shell metacharacter, then use eval to reverse
# that process (while maintaining the separation between arguments), and wrap
# the whole thing up as a single "set" statement.
#
# This will of course break if any of these variables contains a newline or
# an unmatched quote.
#
eval "set -- \$(
printf '%s\\n' "\$DEFAULT_JVM_OPTS \$JAVA_OPTS \$${optsEnvironmentVar}" |
xargs -n1 |
sed ' s~[^-[:alnum:]+,./:=@_]~\\\\&~g; ' |
tr '\\n' ' '
)" '"\$@"'
exec "\$JAVACMD" "\$@"